/*
 * display.c
 *
 * Created: 10/7/2014
 * Author: jiri stepanovsky, jiristepanovsky.cz
 */


#include "display.h"

// initialize ports direction
void HW_init(void)
{
	// segments
	DDRD = b11101111;
	DDRB = b00000001;
	PORTD = b11101111;
	PORTB = b00000001;

	// button
	PORTD |= b00010000;
	
	// wires
	PORTC = b00110000;

	// displays
	DDRB |= b00111110;
	PORTB |= b00000110;

}

// convert specific number to segments
void setSegments(char number)
{
	switch(number){
		case 0: PORTD &= b10011000; PORTB &= b11111110; break; // 0
		case 1: PORTD &= b11111110; PORTB &= b11111110; break; // 1
		case 2: PORTD &= b01011001; PORTB &= b11111110; break; // 2
		case 3: PORTD &= b01011010; PORTB &= b11111110; break; // 3
		case 4: PORTD &= b00111110; PORTB &= b11111110; break; // 4
		case 5: PORTD &= b00011010; PORTB &= b11111111; break; // 5
		case 6: PORTD &= b00011000; PORTB &= b11111111; break; // 6
		case 7: PORTD &= b11111010; PORTB &= b11111110; break; // 7
		case 8: PORTD &= b00011000; PORTB &= b11111110; break; // 8
		case 9: PORTD &= b00011010; PORTB &= b11111110; break; // 9
		case 10:PORTD &= b01111111; PORTB &= b11111111; break; // -
		case 11:PORTD &= b11110111; PORTB &= b11111111; break; // .
		case 12:PORTD &= b11111111; PORTB &= b11111111; break; // 
		case 13:PORTD &= b10011101; PORTB &= b11111111; break; // L
		case 14:PORTD &= b00111000; PORTB &= b11111110; break; // A
		case 15:PORTD &= b00111001; PORTB &= b11111111; break; // F
		case 16:PORTD &= b00011001; PORTB &= b11111111; break; // E
		default: break;
	}
}

// enable specific display
void setDisplay(char display)
{
	switch(display){
		case 0: PORTB &= b11011111; break; // display 1 (minutes)
		case 1: PORTB &= b11111101; break; // display 2 (seconds)
		case 2: PORTB &= b11111011; break; // display 3 (seconds)
		case 3: PORTB &= b11110111; break; // display 4 (frames)
		case 4: PORTB &= b11101111; break; // display 5 (frames)
		default: break;
	}
}

// disable all displays and clear segments
void clear(void)
{
	PORTB |= b00111110 | b00000001;
	PORTD |= b11101111;
}
